Bug 1505185 - dnf incudepkgs broken
Summary: dnf incudepkgs broken
Status: CLOSED RAWHIDE
Alias: None
Product: Fedora
Classification: Fedora
Component: dnf   
(Show other bugs)
Version: rawhide
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: Jaroslav Mracek
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Keywords: Triaged
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2017-10-22 23:09 UTC by nicolas.vieville
Modified: 2018-06-28 08:30 UTC (History)
7 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2018-06-28 08:30:08 UTC
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
tigress.repo (476 bytes, application/octet-stream)
2017-10-23 13:25 UTC, nicolas.vieville
no flags Details
outputs_from_dnf_2.7.4.txt (5.84 KB, application/octet-stream)
2017-10-23 13:29 UTC, nicolas.vieville
no flags Details
outputs_from_dnf_2.7.5.txt (6.71 KB, application/octet-stream)
2017-10-23 13:29 UTC, nicolas.vieville
no flags Details
adobe-linux-i386.repo (199 bytes, application/octet-stream)
2017-10-23 13:29 UTC, nicolas.vieville
no flags Details
adobe-linux-x86_64.repo (183 bytes, application/octet-stream)
2017-10-23 13:29 UTC, nicolas.vieville
no flags Details
dropbox.repo (258 bytes, application/octet-stream)
2017-10-23 13:29 UTC, nicolas.vieville
no flags Details
fedora.repo (1.30 KB, application/octet-stream)
2017-10-23 13:30 UTC, nicolas.vieville
no flags Details
fedora-multimedia.repo (998 bytes, application/octet-stream)
2017-10-23 13:30 UTC, nicolas.vieville
no flags Details
fedora-updates.repo (1.31 KB, application/octet-stream)
2017-10-23 13:30 UTC, nicolas.vieville
no flags Details
negativo17-fedora-cdrtools.repo (685 bytes, application/octet-stream)
2017-10-23 13:30 UTC, nicolas.vieville
no flags Details
playonlinux.repo (168 bytes, application/octet-stream)
2017-10-23 13:30 UTC, nicolas.vieville
no flags Details
remi.repo (854 bytes, application/octet-stream)
2017-10-23 13:30 UTC, nicolas.vieville
no flags Details
rpmfusion-free.repo (1.22 KB, application/octet-stream)
2017-10-23 13:30 UTC, nicolas.vieville
no flags Details
rpmfusion-free-updates.repo (1.23 KB, application/octet-stream)
2017-10-23 13:30 UTC, nicolas.vieville
no flags Details
rpmfusion-nonfree.repo (1.26 KB, application/octet-stream)
2017-10-23 13:30 UTC, nicolas.vieville
no flags Details
rpmfusion-nonfree-updates.repo (1.26 KB, application/octet-stream)
2017-10-23 13:31 UTC, nicolas.vieville
no flags Details
rpm_sphere.repo (846 bytes, application/octet-stream)
2017-10-23 13:31 UTC, nicolas.vieville
no flags Details
russianfedora-free.repo (1.43 KB, application/octet-stream)
2017-10-23 13:31 UTC, nicolas.vieville
no flags Details
russianfedora-free-updates.repo (1.47 KB, application/octet-stream)
2017-10-23 13:31 UTC, nicolas.vieville
no flags Details
russianfedora-nonfree.repo (1.44 KB, application/octet-stream)
2017-10-23 13:31 UTC, nicolas.vieville
no flags Details
russianfedora-nonfree-updates.repo (1.52 KB, application/octet-stream)
2017-10-23 13:31 UTC, nicolas.vieville
no flags Details
tao.repo (366 bytes, application/octet-stream)
2017-10-23 13:31 UTC, nicolas.vieville
no flags Details

Description nicolas.vieville 2017-10-22 23:09:54 UTC
Description of problem:

dnf doesn't filter correctly includepkgs directive from repositories configuration files.

Version-Release number of selected component (if applicable):

dnf-2.7.5-1.fc26.noarch

How reproducible:

Add an includepkgs=package_name in a repository configuration file and dnf upgrade.

Steps to Reproduce:
1. Added adobe-linux-x86_64 repository
2. Installed flash-plugin from adobe-linux-x86_64 repository
3. Added russianfedora-nonfree-updates repository
4. Added includepkgs=skype russianfedora-nonfree-release to /etc/yum.repos.d/russianfedora-nonfree.repo configuration file
5. Tried "dnf upgrade --refresh"

Actual results:

Upgrades flash-plugin from adobe-linux-x86_64 with russianfedora-nonfree-updates one despite the includepkgs directive not listing it.

Expected results:

Don't upgrade flash-plugin installed from adobe-linux-x86_64 repository with the one from russianfedora-nonfree-updates repository because of the directive includepkgs added in russianfedora-nonfree-updates repository configuration file doesn't contain "flash-plugin".

Additional info:

Filtering packages through includepkgs and exclude directives was working correctly with previous version of dnf (2.7.4-1).

Cordially,


-- 
NVieville

Comment 1 Jaroslav Mracek 2017-10-23 09:24:50 UTC
Please could you provide outputs from dnf-2.7.4 and dnf-2.7.5 with the same setting for command "dnf upgrade -v"? DNF-2.7.4 is easily available from copr repository (dnf copr enable rpmsoftwaremanagement/dnf-nightly). 

Please also *.repo files from /etc/yum.repos.d/ and /etc/dnf/dnf.conf could help.

Thanks a lot

Comment 2 nicolas.vieville 2017-10-23 13:25:09 UTC
Created attachment 1342187 [details]
tigress.repo

Comment 3 nicolas.vieville 2017-10-23 13:29:33 UTC
Created attachment 1342188 [details]
outputs_from_dnf_2.7.4.txt

Comment 4 nicolas.vieville 2017-10-23 13:29:40 UTC
Created attachment 1342189 [details]
outputs_from_dnf_2.7.5.txt

Comment 5 nicolas.vieville 2017-10-23 13:29:46 UTC
Created attachment 1342190 [details]
adobe-linux-i386.repo

Comment 6 nicolas.vieville 2017-10-23 13:29:52 UTC
Created attachment 1342191 [details]
adobe-linux-x86_64.repo

Comment 7 nicolas.vieville 2017-10-23 13:29:59 UTC
Created attachment 1342192 [details]
dropbox.repo

Comment 8 nicolas.vieville 2017-10-23 13:30:05 UTC
Created attachment 1342193 [details]
fedora.repo

Comment 9 nicolas.vieville 2017-10-23 13:30:12 UTC
Created attachment 1342194 [details]
fedora-multimedia.repo

Comment 10 nicolas.vieville 2017-10-23 13:30:20 UTC
Created attachment 1342195 [details]
fedora-updates.repo

Comment 11 nicolas.vieville 2017-10-23 13:30:25 UTC
Created attachment 1342196 [details]
negativo17-fedora-cdrtools.repo

Comment 12 nicolas.vieville 2017-10-23 13:30:32 UTC
Created attachment 1342197 [details]
playonlinux.repo

Comment 13 nicolas.vieville 2017-10-23 13:30:38 UTC
Created attachment 1342198 [details]
remi.repo

Comment 14 nicolas.vieville 2017-10-23 13:30:44 UTC
Created attachment 1342199 [details]
rpmfusion-free.repo

Comment 15 nicolas.vieville 2017-10-23 13:30:51 UTC
Created attachment 1342200 [details]
rpmfusion-free-updates.repo

Comment 16 nicolas.vieville 2017-10-23 13:30:57 UTC
Created attachment 1342201 [details]
rpmfusion-nonfree.repo

Comment 17 nicolas.vieville 2017-10-23 13:31:04 UTC
Created attachment 1342202 [details]
rpmfusion-nonfree-updates.repo

Comment 18 nicolas.vieville 2017-10-23 13:31:11 UTC
Created attachment 1342203 [details]
rpm_sphere.repo

Comment 19 nicolas.vieville 2017-10-23 13:31:17 UTC
Created attachment 1342204 [details]
russianfedora-free.repo

Comment 20 nicolas.vieville 2017-10-23 13:31:23 UTC
Created attachment 1342205 [details]
russianfedora-free-updates.repo

Comment 21 nicolas.vieville 2017-10-23 13:31:30 UTC
Created attachment 1342206 [details]
russianfedora-nonfree.repo

Comment 22 nicolas.vieville 2017-10-23 13:31:36 UTC
Created attachment 1342207 [details]
russianfedora-nonfree-updates.repo

Comment 23 nicolas.vieville 2017-10-23 13:31:42 UTC
Created attachment 1342208 [details]
tao.repo

Comment 24 nicolas.vieville 2017-10-23 13:36:45 UTC
Hello Jaroslav,

Here are the outputs and files you asked for.

The outputs were obtained by adding the "--exclude=dnf,dnf-conf,dnf-yum,python2-dnf,python3-dnf" option to each command in order to avoid upgrading/playing_with dnf.

Hope this will be what you asked for.

Please don't hesitate to comment about this subject.

Cordially,


-- 
NVieville

Comment 25 Jaroslav Mracek 2017-10-23 13:54:44 UTC
Thanks a lot. Probably I have the issue. Please can you perform following:

I believe that "russianfedora-nonfree-release", or "skype" is not present at all in "russianfedora-nonfree-nico-updates".

Please remove include from "russianfedora-nonfree-nico-updates" repo file and run "dnf repoquery -repo russianfedora-nonfree-nico-updates skype russianfedora-nonfree-release". If it returns nothing, it is the issue.

Thanks for additional information.

Comment 26 nicolas.vieville 2017-10-23 14:33:50 UTC
Hello,

Removed the includepkgs directive from "russianfedora-nonfree-nico-updates" repo and from "russianfedora-nonfree-nico" repo. 

Then:

#LANG=C dnf repoquery --repo russianfedora-nonfree-nico-updates skype russianfedora-nonfree-release
Last metadata expiration check: 0:03:36 ago on Mon Oct 23 16:20:13 2017.

and

#LANG=C dnf repoquery --repo russianfedora-nonfree-nico skype russianfedora-nonfree-release
Last metadata expiration check: 0:03:55 ago on Mon Oct 23 16:20:51 2017.
russianfedora-nonfree-release-0:26-1.noarch
skype-0:4.3.0.37-4.fc26.i586

Repository "russianfedora-nonfree-nico-updates" gives nothing unless "Last metadata expiration check". 

Repository "russianfedora-nonfree-nico" gives "Last metadata expiration check" and print the names of the two packages queried.

The includepkgs directive have to be set in the two repositories configuration files in order be able to install and get the possible updates for the concerned packages. For the moment, none of these packages have been updated, conducting to an empty list from the "russianfedora-nonfree-nico-updates" repository.

Hope this helps.

Feel free to make any comments about this subject.

Cordially,


-- 
NVieville

Comment 27 Jaroslav Mracek 2017-10-23 15:25:45 UTC
I created a patch that should solve the issue (https://github.com/rpm-software-management/dnf/pull/967)

Comment 28 nicolas.vieville 2017-10-23 15:49:12 UTC
Hello,

Testing the patch from #27 applied on a fresh update of dnf to 2.7.5-1 on fedora 26. 

With the same configuration files for repositories as above, dnf now works correctly with includepkgs directive and doesn't wants to upgrade flash-plugin from adobe with the one from russianfedora anymore. Well done.

Hope this patch will be applied on next dnf update for fedora.

Cordially,


-- 
NVieville

Comment 29 nicolas.vieville 2017-12-11 13:29:30 UTC
Hello,

Do you think this fix https://github.com/rpm-software-management/dnf/commit/094e0659a9db45871dc1f6379e6b3b1ed5b3c077 will be included in next release of Fedora python3-dnf and python2-dnf packages in order to make packages upgrade take care of includepkgs directive?

The fix have been pushed in the github repository, but have not reached the Fedora packages.

Cordially,


-- 
NVieville

Comment 30 Fedora End Of Life 2018-05-03 08:16:38 UTC
This message is a reminder that Fedora 26 is nearing its end of life.
Approximately 4 (four) weeks from now Fedora will stop maintaining
and issuing updates for Fedora 26. It is Fedora's policy to close all
bug reports from releases that are no longer maintained. At that time
this bug will be closed as EOL if it remains open with a Fedora  'version'
of '26'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version'
to a later Fedora version.

Thank you for reporting this issue and we are sorry that we were not
able to fix it before Fedora 26 is end of life. If you would still like
to see this bug fixed and are able to reproduce it against a later version
of Fedora, you are encouraged  change the 'version' to a later Fedora
version prior this bug is closed as described in the policy above.

Although we aim to fix as many bugs as possible during every release's
lifetime, sometimes those efforts are overtaken by events. Often a
more recent Fedora release includes newer upstream software that fixes
bugs or makes them obsolete.

Comment 31 nicolas.vieville 2018-06-06 18:25:26 UTC
Hello,

Sorry for re-opening this bug report, but with Fedora 28 and last dnf available (dnf-2.7.5-12.fc28.noarch), this bug re-appeared with exactly the same symptoms as my first post (flash-plugin from russian repository replace one from adobe repository). 

After applying the same patch as post #29 link to base.py, the issue seems to be fixed (dnf distro-sync and dnf --refresh upgrade fix the problem).

Do you think it will be possible to definitively apply the patch to the next fedora dnf packages, in order to not being surprised with future unattended package upgrades.

Thanks in advance. Any comment about this subject are welcome.

Cordially,


-- 
NVieville

Comment 32 Jaroslav Mracek 2018-06-06 20:25:25 UTC
The patch should be part of dnf-3.0 that is planned to be released in about 30 days into rawhide and Fedora 28.

Comment 33 nicolas.vieville 2018-06-07 16:03:00 UTC
Hello,

Thank you for this information I wasn't aware of. Sorry for the noise, I'll wait for this new release with great interest.

Cordially,


-- 
NVieville

Comment 34 Jaroslav Mracek 2018-06-28 08:30:08 UTC
The issue is solved by dnf-3.0.1-1 that was released into rawhide.


Note You need to log in before you can comment on or make changes to this bug.